#include <Xm/Xm.h>
#include <iostream.h>
#include "global.h"

void da_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  GC             gc;
  Display        *dpy=XtDisplay(drawing_a);
  Window         window=XtWindow(drawing_a);
  Dimension      wd, ht;
  int            i;
  unsigned int   j;
  int            yunits, yoff, yd;
  int            xp;
  float          yf;
  float          ymin,ymax;
  unsigned long  ni,n1,n2;
  char           c_label[256];

         void clearscreen();
  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);

  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);

  if (XtWindow(drawing_a)) clearscreen();

  if (r.n>0){
    XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
    yunits=0;
    for (i=0; i<r.n; i++)
      if (r.view[i].is_visible) yunits+=r.ch[i].height+1;

    yoff=0;
    for (i=0; i<r.n; i++) {
      if(r.view[i].is_visible) {
	yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	yoff+=yd;
	XDrawLine(dpy,window,gc,LMAR,yoff,wd,yoff);
	if(r.view[i].max>r.view[i].min){
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  n2=(unsigned long)(r.t_1*r.ch[i].sr);
	  set_color(drawing_a, colors[r.ch[i].color], NULL, gc);
	  for (xp=LMAR; xp<wd; xp++) {
	    n1=n2;
	    if(n1<0) n1=0;
	    n2=(unsigned long)((r.t_1*r.ch[i].sr)+
			     (r.t_2-r.t_1)*r.ch[i].sr*(xp+1-LMAR)/(wd-LMAR));
	    if(n2>=r.ch[i].n) n2=r.ch[i].n-1;
	    if(n1>n2) n2=n1;
	    if(n1>=r.ch[i].n) n1=0;
	    if(n2>=r.ch[i].n) n2=r.ch[i].n-1;
	    ymax=r.ch[i].data[n1];
	    ymin=r.ch[i].data[n1];
	    for (ni=n1; ni<=n2; ni++) {
	      if (r.ch[i].data[ni]>ymax) ymax=r.ch[i].data[ni];
	      if (r.ch[i].data[ni]<ymin) ymin=r.ch[i].data[ni];
	    }
	    XDrawLine(dpy,window,gc,xp,(int)(yoff-yf*(ymin-r.view[i].min)),
		      xp,(int)(yoff-yf*(ymax-r.view[i].min)));
	  }
	  set_color(drawing_a, "black", NULL, gc);
	  if (r.view[i].is_active) {
	    set_color(drawing_a, "blue", "White", gc);
	    XDrawImageString(dpy, window, gc, 0, (int)(yoff+15-yd),
			     "A", strlen("A")); 
	    set_color(drawing_a, "black", NULL, gc);
	  }
	  else {
	    set_color(drawing_a, "red", "White", gc);
	    XDrawImageString(dpy, window, gc, 0, (int)(yoff+15-yd),
			     "P", strlen("P")); 
	    set_color(drawing_a, "black", NULL, gc);
	  }
	}
      }
    }
    /* comments */
    for (j=0; j<r.comments->n; j++) {
      if ((r.comments->time[j] <= r.t_2) && (r.comments->time[j] >= r.t_1)) {
	/* draw line for comment */
	xp=LMAR+(int)(((float)r.comments->time[j]-r.t_1)*(wd-LMAR)/(r.t_2-r.t_1));
	if ( !(strcmp("start", r.comments->comment[j])) || !(strcmp("end", r.comments->comment[j])) ){
        sprintf(c_label, " %s ", r.comments->comment[j]);
	set_color(drawing_a, "black", NULL, gc);
	XDrawLine(dpy,window,gc, xp,0, xp,ht);
	set_color(drawing_a, "black", "White", gc);
	XDrawImageString(dpy, window, gc, xp+1, ht-1, c_label, strlen(c_label));
	}else{
	  sprintf(c_label, " %d ", j+1);
	  set_color(drawing_a, "red", NULL, gc);
	  XDrawLine(dpy,window,gc, xp,0, xp,ht);
	  set_color(drawing_a, "black", "White", gc);
	  XDrawImageString(dpy, window, gc, xp+1, ht-1, c_label, strlen(c_label));
	  
	}
      }
    }
    /* Marks */
    if (r.tm_1>=0 && r.tm_2>=0) {
      if (r.tm_1>=r.t_1 && r.tm_1<=r.t_2) {
	xp=LMAR+(int)((r.tm_1-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	set_color(drawing_a, "Cyan", NULL, gc);
	XDrawLine(dpy,window,gc,xp,0, xp,ht);
	set_color(drawing_a, "black", NULL, gc);
      }
      if (r.tm_2>=r.t_1 && r.tm_2<=r.t_2) {
	xp=LMAR+(int)((r.tm_2-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	set_color(drawing_a, "Cyan", NULL, gc);
	XDrawLine(dpy,window,gc,xp,0, xp,ht);
	set_color(drawing_a, "black", NULL, gc);
      }
    }
    set_color(drawing_a, "black", NULL, gc);
  }
  XFreeGC(dpy,gc);
}

void clearscreen() {
  GC          gc;
  Display     *dpy=XtDisplay(drawing_a);
  Window      window=XtWindow(drawing_a);
  XFontStruct *font;
  Dimension   width, height;
  int         i, j, xp;
  float       yf;
  float       ticmin, ticstep, ticmax;
  double      wert;
  int         y0, yd, ntic, yunits;
  int         ypos;
  char        ylabel[20];

  extern int scale(float fmn, float fmx, int n, float *valmin, float *step, float *valmax);

  /* graphic context stuff */
  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  font=XLoadQueryFont(dpy, "fixed");
  XtVaGetValues(drawing_a, XmNwidth, &width, XmNheight, &height, NULL);
  XClearWindow(dpy,window);

  /* y-axis */
  if (r.n>0) {
    XDrawLine(dpy, window, gc, LMAR, 0, LMAR, height);
    yunits=0; for (i=0; i<r.n; i++) if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
    yd=height/yunits; y0=0;
    for (i=0; i<r.n; i++) {
      if (r.view[i].is_visible) {
	yf=(float)yd*(r.ch[i].height+1)/(r.view[i].max-r.view[i].min);
	y0+=(r.ch[i].height+1)*yd;
	ntic=(yd*(r.ch[i].height+1)/30)+1;
	XDrawLine(dpy, window, gc, 0, y0, width, y0);
	if (ntic>=2) {
	  scale(r.view[i].min, r.view[i].max, ntic, &ticmin, &ticstep, &ticmax);
	  for (j=-1; j<ntic+1; j++) {
	    ypos=(int)(y0-(yf*(ticmin+j*ticstep-r.view[i].min)));
	    if ((ypos<y0-10) && (ypos>30+y0-yd*(r.ch[i].height+1))) {
	      XDrawLine(dpy, window, gc, LMAR-TICWIDTH, ypos, LMAR, ypos);
	      wert=floor((ticmin+ticstep*j)*10000.0+0.5)/10000.0;
	      sprintf(ylabel,"%6.4g", wert);
	      XDrawString(dpy, window, gc, 5, ypos+font->ascent/2,ylabel, 6);
	    }
	  }
	}
      }
    }
  }
  XFreeGC(dpy,gc);
  XFreeFont(dpy,font);
}


















