/* Program  TSA2ASC.C          */
/* By Harald Stauss         */
/* Last change 21 Oct. 1995 */

#include "tsa.h"

main(int argc, char *argv[])
{
         short    i,chn;
unsigned long     n;
         char     fin[255], fout[255];
         REGIST   r;
         float    wert;

printf("TSA2ASC Ver.1.0 by H. Stauss, 1995 \n");

if (argc != 3)
   {
   printf("Number of parameters wrong! \n");
   printf("Rectifies channel number chn \n");
   printf("play fin fout \n");
   printf("fin    : name of input file (*.tsa). \n");
   printf("fout   : name of output file (*.asc). \n");
   goto ende;
   }

// Parameter einlesen 
strcpy(fin ,argv[1]);
strcpy(fout,argv[2]);

printf("In-File   : %s \n",fin);
printf("Out-File  : %s \n",fout);

// Datei einlesen
r.ReadTSA(fin);

printf("Number of channels: %d  \n",r.n);
for (i=0; i < r.n; i++)
   printf("Number of lines in channel %d: %u \n",i+1,r.ch[i].n);

// Datei schreiben
r.WriteASCII(fout);

ende:
return(0);
} /* Ende von main */



